/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package com.jcg.prototypescopebean;

import org.springframework.beans.factory.config.BeanDefinition;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.ComponentScan;
import org.springframework.context.annotation.Configuration;
import org.springframework.context.annotation.Scope;

import java.util.function.Function;

/**
 *
 * @author omozegieaziegbe
 */
@Configuration
@ComponentScan(basePackages = { "com.jcg.prototypescopebean" })
public class AppConfig {

    @Bean(name="MessageService")
    @Scope(BeanDefinition.SCOPE_PROTOTYPE)
    public MessageService createMessageService(String message) {
        
        return new MessageService(message);
    }
    
    @Bean
    public Function<String, MessageService> serviceFactory() {
        return message -> new MessageService(message);
    }
}
